function SynchronizerController(use_player_id){
	var self = this; self.name = "SynchronizerController"; // MANDATORY

    this.ACTION_STATUS = 0;
    this.ACTION_PLAY = 1;
    this.ACTION_PRELOAD = 2;
    
    this.MODE_NORMAL = 0
    this.MODE_MASTER = 2;
    this.MODE_SLAVE = 3;
    
    this.api_connector = new ApiConnector();
    this.server_timer = 0;
    this.server_interval = 1000; 
    this.scan_interval = 20000;
    this.mode = this.MODE_NORMAL;
    this.using_mode = this.MODE_NORMAL;
    this.ip = "0.0.0.0";
    this.subnet = "0.0.0.0";
    this.port = 41414;
    this.servers = [];
    this.times = [];
    this.highest_id = 0;
    this.master_server_id = 0;
    
    this.clock = 0;
		this.searching = false;
		
		this.connections = [];
		for(var i=1;i<255;i++){this.connections[i] = {"ip":"","checked":false,"player_id":0,"socket":false,"time":0,"alive":false};}
		this.check_timer = 0;
		this.members_timer = 0;
		this.scanning = false;
		
		this.status = {};
		this.last_data_package = [];
		
		this.player_id = 0;
		if(use_player_id != 0){
			this.player_id = use_player_id;
		}

    this.update = function(sync_mode,sync_port,sync_machines){
        clearTimeout(self.server_timer);
        if(typeof(sync_mode) !== "undefined"){
            self.mode = sync_mode;
						if(self.OS.sync_master_supported){
							if(self.using_mode != sync_mode){
	                self.using_mode = self.MODE_MASTER;
	            }
						}else{
							self.mode = self.MODE_SLAVE;
							self.using_mode = self.MODE_SLAVE;
						}
            
        }
        if(typeof(sync_port) !== "undefined"){
            if(sync_port > 49152 && sync_port < 65535){
								if(self.port != 41414 && self.port != sync_port){
									// TODO 
									// Make OS Change Websocket Server Port
								}
                self.port = sync_port;
            }
        }
        self.master_last_timestamp = self.getDate().getTime();
        
        if(self.mode == self.MODE_MASTER || self.mode == self.MODE_SLAVE){
						self.checkServerStatus();
						self.OS.findSyncIp(self.onIpFound);
        }else{
					// TODO 
					// Stop OS Websocket Server
				}  
				self.check_members(); 
				
    };
		
		this.onIpFound = function(ip){
			self.log("My Ip : "+self.ip);
			self.log("onIpFound : "+ip);
			if(ip != self.ip){
				self.log("onIpFound : Setting IP");
				self.ip = ip;
				self.log("onIpFound : My new IP "+self.ip);
				self.subnet = self.ip.substr(0,self.ip.lastIndexOf(".")+1);   
				self.log("onIpFound : My new subnet "+self.subnet);
				var index = self.ip.substr(self.ip.lastIndexOf(".")+1,self.ip.length); 
				self.log("onIpFound : My new index "+index);
				//self.servers[index] = {"ip":self.ip,"checked":true,"player_id":self.core_id,"socket":false,"time":0,"alive":true};
				self.check_network_scan();
			}else if(ip == "0.0.0.0"){
				self.log("onIpFound : keep looking ... retry");
				setTimeout(function(){
					self.log("onIpFound : retrying find IP ... ");
					self.OS.findSyncIp(self.onIpFound);
				},2000);
			}		
		};
    
    this.checkServerStatus = function(){
				clearTimeout(self.server_timer);
        if(self.using_mode == self.MODE_MASTER && self.mode == self.MODE_MASTER){
            self.log("<<<<<<< USING SYNC MODE MASTER with IP: "+self.ip+" >>>>>>");
        }else if(self.using_mode == self.MODE_MASTER && self.mode == self.MODE_SLAVE){
            self.log("<<<<<<< USING SYNC MODE FAKE MASTER with IP: "+self.ip+" >>>>>>");
        }else{
            self.log("<<<<<<< USING SYNC MODE SLAVE with IP: "+self.ip+" - Master Player ID is : "+self.master_server_id);
        }
				    
        //if(self.OS.sync_master_supported){
            if(!self.OS.websocket_server && self.OS.sync_master_supported){
                self.log("Starting Websocket Server ...");
                self.OS.socketServerStart(self.port,self.onServerSocketOpen,self.onServerRecieveMessage,self.onServerSocketClose);
            }else{
							var broadcast_message = {
									sender:self.name,
									action:{
											do:"status",
											default_mode: self.mode,
											using_mode: self.using_mode,
											player_id : self.player_id,
											time:new Date().getTime()
									}
							};
              self.broadcast(broadcast_message,true);
							broadcast_message = null;
            }
						
        //}else{
        //    self.log("Platform has no Websocket Server Support");
        //    self.notifyError(self.ERROR['SYNCHRONIZER_CONTROLLER']+1,self.name+": WARNING !! Trying to use as SyncMaster ! : Platform has NO Websocket Server Support, can't become MASTER");   
        //}
				self.checkMasterAlive();
				self.server_timer = setTimeout(self.checkServerStatus,self.server_interval); 
    };

		this.check_network_scan = function(){
			clearTimeout(self.check_timer);	
			if(!self.scanning){
				self.scan();
			}else{
				self.OS.findSyncIp(self.onIpFound);
				self.log("Reconnect known servers ...");
				for(i=1;i<self.connections.length;i++){
					if(self.connections[i].socket){
						self.log("Saved Server on : "+self.connections[i].ip);
						self.connect_socket_client(i);
					}
				}					
			}
			self.check_timer = setTimeout(self.check_network_scan,self.scan_interval);
		};
		
		this.scan = function(){
			self.log("Start network scan ... ");
			self.scanning = true;
			self.log("Create connections");
			var temp_websocket = null;
			for(var i=1;i<255;i++){
				//if(self.subnet+i != self.ip){
					if(!self.connections[i].checked && !self.connections[i].socket){
						try{
							temp_websocket = new WebSocket("ws://"+self.subnet+i+":"+self.port+"/");
							temp_websocket.onopen = self.onWebsocketConnectorOpen;
							temp_websocket.onclose = self.onWebsocketConnectorClose;
							temp_websocket.start = new Date().getTime();
							temp_websocket.index = i;				 
						}catch(e){
							self.connections[i].checked = true;						
						}
					}
				//}else{
				// self.connections[i].checked = true;
				//}
			}
	};
		
		this.onWebsocketConnectorOpen = function(e){
			var server_index = self.getServerIndex(e.currentTarget.url);
			e.currentTarget.onopen = null;
			e.currentTarget.onclose = null;
			if(typeof(self.servers[server_index]) === "undefined"){
				self.connections[server_index].ip = self.subnet+server_index; 
				self.connections[server_index].socket = true; 
				self.connections[server_index].checked = true;
				self.connect_socket_client(server_index);
				e.currentTarget.close();
			}
			e.currentTarget.start = null;
			e.currentTarget.index = null;
		};
		
		this.onWebsocketConnectorClose = function(e){
			var server_index = e.currentTarget.index;
			var elapsed = new Date().getTime() - e.currentTarget.start;
			e.currentTarget.onopen = null;
			e.currentTarget.onclose = null;
			if(isNaN(elapsed)){elapsed = 0;}
			var delay_reconnect = 30000-elapsed;
			if(delay_reconnect <= 1000){delay_reconnect = 1000;}
			if(isNaN(delay_reconnect)){delay_reconnect = 1000;}
			var reconnect = true;
			self.log(self.getFullDateFormatted()+" Websocket Close Event : Elapsed Time for ["+server_index+"]: "+elapsed+" Retry with delay : "+delay_reconnect);
			if(!self.connections[server_index].checked && !self.connections[server_index].socket){
				//if(!self.OS.sync_master_supported){
					if(self.master_server_id != 0){
							reconnect = false;
					}
				//}
				if(reconnect){
					setTimeout(function(){
						var temp_websocket = new WebSocket("ws://"+self.subnet+server_index+":"+self.port+"/");
						temp_websocket.onopen = self.onWebsocketConnectorOpen;
						temp_websocket.onclose = self.onWebsocketConnectorClose;
						temp_websocket.start = new Date().getTime();
						temp_websocket.index = server_index;				
					},delay_reconnect);
				}
			}
			e.currentTarget.close();
			e.currentTarget.start = null;
			e.currentTarget.index = null;
		};
		
		this.connect_socket_client = function(index){
			try{
				if(typeof(self.servers[index]) == "undefined"){
						self.servers[index] = self.connections[index];
						self.servers[index].socket = new WebSocket("ws://"+self.subnet+index+":"+self.port+"/");
						self.servers[index].socket.onopen = self.onClientOpen;
						self.servers[index].socket.onmessage = self.onClientMessageRecieve;
				}else if(self.servers[index].socket.readyState >= 2 || !self.servers[index].alive){
					//self.servers[index].socket.close();
					self.servers[index].socket = null;
					self.servers[index].socket = new WebSocket("ws://"+self.subnet+index+":"+self.port+"/");
					self.servers[index].socket.onopen = self.onClientOpen;
					self.servers[index].socket.onmessage = self.onClientMessageRecieve;
					self.servers[index].socket.onclose = self.onClientClose; 
					//self.servers[index].socket.onerror = self.onClientError; 
				}
			}catch(e){
				self.log("connect_socket_client error");		
			}
		};
		
    this.broadcast = function(msg,force){
        if(typeof(force) === "undefined"){force = false;}
        if(self.using_mode == self.MODE_MASTER || force){
            self.OS.socketServerBroadcast(msg);
        }else if(self.using_mode == self.MODE_SLAVE){
						var index = -1;
						for(var server in self.servers){
							if(self.servers[server].player_id == self.master_server_id){
								index = server;
								break;;
							}
						}
						if(index >= 0){
							try{
								self.servers[index].socket.send(JSON.stringify(msg));
							}catch(e){
								self.log("Could not EMIT to master from slave");
							}
						}
				}
    };
    
    this.checkActualMode = function(action){
				var remote_id = parseInt(action.player_id);
        if(self.using_mode == self.MODE_MASTER){
            // Check other MASTERs
            if(action.default_mode == self.MODE_MASTER && action.using_mode == self.MODE_MASTER){
                // Another MASTER found -> Check Highest Player Id
                if(self.mode == self.MODE_MASTER){
                    
                    self.log("Another MASTER found -> Check Highest Player Id - Remote ID: "+remote_id);
                    if(remote_id > self.highest_id){
                        self.highest_id = remote_id;
                    }
                    self.log("My ID : "+self.player_id+" Highest ID : "+self.highest_id);
                    if(self.highest_id > self.player_id){
                        if(self.using_mode != self.MODE_SLAVE){
                            self.using_mode = self.MODE_SLAVE;
                            $(self).trigger("onSyncChangeMode");
                        }
                        self.master_server_id = self.highest_id;
                        //self.master_last_timestamp = self.getDate().getTime();
                    }else{
                        if(self.using_mode != self.MODE_MASTER){
                            self.using_mode = self.MODE_MASTER;
                            $(self).trigger("onSyncChangeMode");
                        }
                    }
                }else{
                    self.master_server_id = 0;
                    if(self.using_mode != self.MODE_SLAVE){
                        self.using_mode = self.MODE_SLAVE;
                        $(self).trigger("onSyncChangeMode");
                    }
                    //self.master_last_timestamp = self.getDate().getTime();
                }
            }else if(self.mode == self.MODE_SLAVE && action.default_mode == self.MODE_SLAVE && action.using_mode == self.MODE_MASTER){
								/*
                if(remote_id > self.highest_id){
                    self.highest_id = remote_id;
                }
                self.log("My ID : "+self.core_id+" Highest ID : "+self.highest_id);
                if(self.highest_id > self.core_id){
                    if(self.using_mode != self.MODE_SLAVE){
                        self.using_mode = self.MODE_SLAVE;
                        $(self).trigger("onSyncChangeMode");
                    }
                    self.master_server_id = self.highest_id;
                    self.master_last_timestamp = self.getDate().getTime();
                }    
								*/
								if(parseInt(action.player_id) != self.player_id){
									self.log("Another FAKE MASTER found -> Connecting to - Remote ID: "+remote_id);
										self.master_server_id = parseInt(action.player_id); 
										if(self.using_mode != self.MODE_SLAVE){
												self.using_mode = self.MODE_SLAVE;
												$(self).trigger("onSyncChangeMode");
										}         
								}
								
								//self.master_last_timestamp = self.getDate().getTime();   
            }
        }else if(self.using_mode == self.MODE_SLAVE && action.using_mode == self.MODE_MASTER){
            // MASTER Server Found.
            if(remote_id != self.player_id){
							if(remote_id != self.master_server_id){
								if(self.master_server_id == 0 || action.default_mode == self.MODE_MASTER){
									self.master_server_id = parseInt(action.player_id);          
								}
							}
            }
            //self.master_last_timestamp = self.getDate().getTime();            
        }
        
    };
           
    this.checkMasterAlive = function(action){
        if(self.using_mode == self.MODE_SLAVE){
            var inactive_milliseconds = self.getDate().getTime() - self.master_last_timestamp;
            if(inactive_milliseconds > 10000){
                if(self.master_server_id > 0){
                    self.log("Master connection lost !!!");
                    self.master_server_id = 0;
										self.scanning = false;
                }else{
										if(self.OS.sync_master_supported){
												self.log("No Master found ... try to become a MASTER");
		                    if(self.using_mode != self.MODE_MASTER){
														//self.servers = [];
		                        self.using_mode = self.MODE_MASTER;
		                        $(self).trigger("onSyncChangeMode");
		                    }
										}
                }
            }
        }
    };
    
    this.onClientMessageRecieve = function(e){
				var server_index = self.getServerIndex(e.currentTarget.url);
        var data = JSON.parse(e.data);
        if(typeof(data) === "object"){
            if(data.hasOwnProperty("sender")){
                if(data.sender == self.name){
										self.checkActualMode(data.action);
										var remote_id = parseInt(data.action.player_id);
										if(remote_id == self.master_server_id && data.action.using_mode == self.MODE_MASTER){
											self.master_last_timestamp = self.getDate().getTime();
										}
                    self.times[server_index] = data.action.time;
										if(typeof(self.servers[server_index]) !== "undefined"){
											self.servers[server_index].player_id = data.action.player_id;
											self.servers[server_index].time = new Date().getTime();		
										}
                    $(self).trigger("onStatusSyncRecieve",[data.action]);
                }else{
										self.checkDataPackage(data);
                }
            }
        }
    };
		
		this.checkDataPackage = function(data){
			try{
				if(self.last_data_package[data.action.do].action.time != data.action.time && self.last_data_package[data.action.do].action.do == data.action.do){
					self.last_data_package[data.action.do] = data;
					$(self).trigger("on"+data.sender+"SyncRecieve",[data.action]);
				}else{
					self.log("Sync Message Repeated");
				}
			}catch(e){
				self.last_data_package[data.action.do] = data;
			}
		};
    
    this.onClientOpen = function(e){
				var server_index = self.getServerIndex(e.currentTarget.url);
        self.log("onClientOpen : Websocket Connected !! "+self.subnet+server_index);
    };
    
    this.onClientClose = function(e){
				var server_index = self.getServerIndex(e.currentTarget.url);
        self.log("onClientClose : Websocket Disconnected !! "+self.subnet+server_index);
    };
    
    this.onClientError = function(e){
				var server_index = self.getServerIndex(e.currentTarget.url);
				self.log("onClientError : Websocket Error !! "+self.subnet+server_index);
    };
		
		this.onServerRecieveMessage = function(msg){
			self.log("onServerRecieveMessage : Recieved from client");
			try{
				var data = false;
				if(typeof(msg) === "object"){
					data = msg;
				}else{
					data = JSON.parse(msg);
				}
				if(data.hasOwnProperty("sender")){
					self.checkDataPackage(data);
				}
			}catch(e){
				self.log("onServerRecieveMessage : Unable to check data package");
			}
		};
		
		this.onServerSocketOpen = function(ip){
			self.log("onServerSocketOpen : opened a connection  ");
		};
		
		this.onServerSocketClose = function(ip){
			self.log("onServerSocketClose : closed a connection");
		};
		
		
    this.getAverageDelay = function(){
        var timestamp = self.getDate().getTime();
        var sum = 0;
        var count = 0;
        for(var time in self.times){
            sum+= (timestamp - self.times[time]);
            count++;
        }
        if(count > 0){
            sum = parseInt(sum /count);
        }else{
            sum = 0;
        }
        return sum*-1;
    };
    
    this.stop = function(){
        clearTimeout(self.server_timer);
        clearTimeout(self.check_timer);
    };
    
    this.unload = function(){
        clearTimeout(self.server_timer);
        clearTimeout(self.check_timer);
        self.api_connector = null;  
    };
    
    this.getServerIndex = function(url){
        url = url.replace("http://","");
        url = url.replace(":"+self.port,"");
        url = url.replace("/","");
        return parseInt(url.substring(url.lastIndexOf('.')+1,url.length));
    };
		
		this.check_members = function(){
			clearTimeout(self.members_timer);
			//self.log("Check Members ...");
			var now = new Date().getTime();		
			for(var i in self.servers){
				if(now - self.servers[i].time < 5000){
					self.servers[i].alive = true;
				}else{
					self.servers[i].alive = false;
				}
			}
			self.update_status(self.servers);
			self.members_timer = setTimeout(self.check_members,1500);
		};
		
		this.update_status = function(connections){
			self.status = null;
			self.status = {
				ip:self.ip,
				port:self.port,
				mode:self.mode,
				player_id:self.player_id,
				using_mode:self.using_mode,
				members: []
			};
			for(var c in connections){
				if(typeof(connections[c].ip) !== "undefined"){
					self.status.members.push({ip:connections[c].ip,player_id:connections[c].player_id,alive:connections[c].alive});
				}
			}
			if(self.content_api){
				self.content_api.updateInfo(self.name,self.status);
				self.content_api.broadcastApiContentEvent(self.content_api.API_PLAYER_INFO,self.content_api.info);
			}
		};
		
		this.getInfo = function(){
			return self.status;
		}
}	
SynchronizerController.prototype = new SystemController();
    
