function Screen(){};

Screen.prototype = new BasicScreenController();
Screen.prototype.constructor = Screen();


// Reference to "this" that won't get clobbered by some other "this"
//Screen.prototype.self = this;

Screen.prototype.name = "VENCO_RS232";

/*
 * Timers use
 * if (timer = * ) it will load if (timer = 0) it won't load
 * Once init is called, timeouts references are stored here
 */

Screen.prototype.timers = {
  power: 1,
  channel: 0,
  schedule: 1
};

Screen.prototype.maxAttempts = {
  power: 3,
  channel: 0,
  schedule: 1
};

//Conf

Screen.prototype.portValues = {
  name: "",
  config: {
    baudRate: 57600,
    dataBits: 8,
    stopBits: 1
  },
  parser : {
      type : 'byteLength' ,
      delimiter : 1
  }
};

//PROTOTYPING
/******************************** INIT PROTOTYPING ********************************/

Screen.prototype.formatRemoteId = function(id){
  return ("00" + id.toString(16)).substr(-2);
};

Screen.prototype.loadDriver = function(platform){
  if(typeof RS232_driverController !== "function"){
    eval("eval")(fs.readFileSync("./app/screenDrivers/RS232.js") + "");
  }
  return new RS232_driverController();
};

Screen.prototype.loadPortValues = function(){};

Screen.prototype.generatePowerQuerry = function(){
  var command = "A,200,000";
  return command;
};

/******************************** STATUS PROTOTYPING ********************************/

Screen.prototype.translatePowerQuerry = function(data){
  this.status.lastCMD = data.toString("ascii");
  data = data.toString();
  console.debug("DATA RECEIVED: ", data);
  switch(data){
    case "0":
    case "2":
      this.status.power = 0;
      this.status.tstamp = Math.floor(new Date().getTime()/1000);
      this.attemptsCounter.power = this.maxAttempts.power;
      break;
    case "1":
      this.status.power = 1;
      this.status.tstamp = Math.floor(new Date().getTime()/1000);
      this.attemptsCounter.power = this.maxAttempts.power;
      break;
    default:
      if(!(this.attemptsCounter.power < this.maxAttempts.power)){
        this.status.power = -1;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        break;
      }
  }
};

Screen.prototype.endPowerQuerry = function(){
  return;
};

/******************************** CHANNEL PROTOTYPING ********************************/

Screen.prototype.generateChannelQuerry = function(){
  var command = "A,201,000";
  return command;
}

Screen.prototype.translateChannelQuerry = function(data){
  this.status.lastCMD = data.toString("ascii");

  switch(data){
    case "0":
      this.status.channel = "VGA";
      this.status.tstamp = Math.floor(new Date().getTime()/1000);
      this.attemptsCounter.channel = this.maxAttempts.channel;
      break;
    case "1":
      this.status.channel = "DVI";
      this.status.tstamp = Math.floor(new Date().getTime()/1000);
      this.attemptsCounter.channel = this.maxAttempts.channel;
      break;
    case "2":
      this.status.channel = "COMPOSITE";
      this.status.tstamp = Math.floor(new Date().getTime()/1000);
      this.attemptsCounter.channel = this.maxAttempts.channel;
      break;
    case "3":
      this.status.channel = "SVIDEO";
      this.status.tstamp = Math.floor(new Date().getTime()/1000);
      this.attemptsCounter.channel = this.maxAttempts.channel;
      break;
    default:
      if(!(this.attemptsCounter.power < this.maxAttempts.power)){
        this.status.channel = "Unknown: " + data;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
      }
      break;
  }
  return;
}

Screen.prototype.endChannelQuerry = function (){};

/******************************** SCHEDULE PROTOTYPING ********************************/

Screen.prototype.generateScheduleQuerry  = function(){return "";};

Screen.prototype.translateScheduleQuerry = function(data){return;};

Screen.prototype.endScheduleQuerry = function(){
  this.attemptsCounter.schedule = this.maxAttempts.schedule;
  return;
};

/******************************** MISC PROTOTYPING ********************************/

Screen.prototype.generateOnQuerry = function(){
console.debug("GENERATE ON QUERY");
  var command = "A,181,000";
  return command;
};

Screen.prototype.translateOnQuerry = function(data){return;};

Screen.prototype.generateOffQuerry = function(){
console.debug("GENERATE OFF QUERY");
  var command = "A,180,000";
  return command;
}

Screen.prototype.translateOffQuerry = function(data){return;};

/******************************** FREE COMMAND: CUSTOM PROTOTYPING ********************************/

Screen.prototype.generateFreeQuerry = function(command){
  return (command + "\r");
};

Screen.prototype.translateFreeQuerry = function(data){
  return;
};

Screen.prototype.endFreeQuerry = function(){
  return;
};
